org.apache.tomcat.util.digester

## Class FactoryCreateRule

- java.lang.Object
- - org.apache.tomcat.util.digester.Rule
  - - org.apache.tomcat.util.digester.FactoryCreateRule

    public class FactoryCreateRule
    extends Rule

Rule implementation that uses an `ObjectCreationFactory` to create a new object which it pushes onto the object stack. When the element is complete, the object will be popped.

This rule is intended in situations where the element's attributes are needed before the object can be created. A common scenario is for the ObjectCreationFactory implementation to use the attributes as parameters in a call to either a factory method or to a non-empty constructor.

### Field Summary

Fields
`protected String` `attributeName` The attribute containing an override class name if it is present.
`protected String` `className` The Java class name of the ObjectCreationFactory to be created.
`protected ObjectCreationFactory` `creationFactory` The object creation factory we will use to instantiate objects as required based on the attributes specified in the matched XML element.

### Fields inherited from class org.apache.tomcat.util.digester.Rule

`digester, namespaceURI`

### Constructor Summary

Constructors
Constructor and Description
`FactoryCreateRule(Class<?> clazz)` Construct a factory create rule that will use the specified class to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.
`FactoryCreateRule(Class<?> clazz, boolean ignoreCreateExceptions)` Construct a factory create rule that will use the specified class to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.
`FactoryCreateRule(Class<?> clazz, String attributeName)` Construct a factory create rule that will use the specified class (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.
`FactoryCreateRule(Class<?> clazz, String attributeName, boolean ignoreCreateExceptions)` Construct a factory create rule that will use the specified class (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.
`FactoryCreateRule(ObjectCreationFactory creationFactory)` Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.
`FactoryCreateRule(ObjectCreationFactory creationFactory, boolean ignoreCreateExceptions)` Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.
`FactoryCreateRule(String className)` Construct a factory create rule that will use the specified class name to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.
`FactoryCreateRule(String className, boolean ignoreCreateExceptions)` Construct a factory create rule that will use the specified class name to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.
`FactoryCreateRule(String className, String attributeName)` Construct a factory create rule that will use the specified class name (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.
`FactoryCreateRule(String className, String attributeName, boolean ignoreCreateExceptions)` Construct a factory create rule that will use the specified class name (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.

### Method Summary

Methods
`void` `begin(String namespace, String name, Attributes attributes)` Process the beginning of this element.
`void` `end(String namespace, String name)` Process the end of this element.
`void` `finish()` Clean up after parsing is complete.
`protected ObjectCreationFactory` `getFactory(Attributes attributes)` Return an instance of our associated object creation factory, creating one if necessary.
`String` `toString()` Render a printable version of this Rule.

### Methods inherited from class org.apache.tomcat.util.digester.Rule

`begin, body, body, end, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### attributeName

    protected String attributeName

The attribute containing an override class name if it is present.

#### className

    protected String className

The Java class name of the ObjectCreationFactory to be created. This class must have a no-arguments constructor.

#### creationFactory

    protected ObjectCreationFactory creationFactory

The object creation factory we will use to instantiate objects as required based on the attributes specified in the matched XML element.

### Constructor Detail

#### FactoryCreateRule

    public FactoryCreateRule(String className)

Construct a factory create rule that will use the specified class name to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.

Exceptions thrown during the object creation process will be propagated.

Parameters:
  `className` - Java class name of the object creation factory class

#### FactoryCreateRule

    public FactoryCreateRule(Class<?> clazz)

Construct a factory create rule that will use the specified class to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.

Exceptions thrown during the object creation process will be propagated.

Parameters:
  `clazz` - Java class name of the object creation factory class

#### FactoryCreateRule

    public FactoryCreateRule(String className,
                     String attributeName)

Construct a factory create rule that will use the specified class name (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.

Exceptions thrown during the object creation process will be propagated.

Parameters:
  `className` - Default Java class name of the factory class
  `attributeName` - Attribute name which, if present, contains an override of the class name of the object creation factory to create.

#### FactoryCreateRule

    public FactoryCreateRule(Class<?> clazz,
                     String attributeName)

Construct a factory create rule that will use the specified class (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.

Exceptions thrown during the object creation process will be propagated.

Parameters:
  `clazz` - Default Java class name of the factory class
  `attributeName` - Attribute name which, if present, contains an override of the class name of the object creation factory to create.

#### FactoryCreateRule

    public FactoryCreateRule(ObjectCreationFactory creationFactory)

Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.

Exceptions thrown during the object creation process will be propagated.

Parameters:
  `creationFactory` - called on to create the object.

#### FactoryCreateRule

    public FactoryCreateRule(String className,
                     boolean ignoreCreateExceptions)

Construct a factory create rule that will use the specified class name to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.

Parameters:
  `className` - Java class name of the object creation factory class
  `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

#### FactoryCreateRule

    public FactoryCreateRule(Class<?> clazz,
                     boolean ignoreCreateExceptions)

Construct a factory create rule that will use the specified class to create an `ObjectCreationFactory` which will then be used to create an object and push it on the stack.

Parameters:
  `clazz` - Java class name of the object creation factory class
  `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

#### FactoryCreateRule

    public FactoryCreateRule(String className,
                     String attributeName,
                     boolean ignoreCreateExceptions)

Construct a factory create rule that will use the specified class name (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.

Parameters:
  `className` - Default Java class name of the factory class
  `attributeName` - Attribute name which, if present, contains an override of the class name of the object creation factory to create.
  `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

#### FactoryCreateRule

    public FactoryCreateRule(Class<?> clazz,
                     String attributeName,
                     boolean ignoreCreateExceptions)

Construct a factory create rule that will use the specified class (possibly overridden by the specified attribute if present) to create an `ObjectCreationFactory`, which will then be used to instantiate an object instance and push it onto the stack.

Parameters:
  `clazz` - Default Java class name of the factory class
  `attributeName` - Attribute name which, if present, contains an override of the class name of the object creation factory to create.
  `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

#### FactoryCreateRule

    public FactoryCreateRule(ObjectCreationFactory creationFactory,
                     boolean ignoreCreateExceptions)

Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.

Parameters:
  `creationFactory` - called on to create the object.
  `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

### Method Detail

#### begin

    public void begin(String namespace,
             String name,
             Attributes attributes)
               throws Exception

Process the beginning of this element.

Overrides:
  `begin` in class `Rule`
Parameters:
  `attributes` - The attribute list of this element
  `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
  `name` - the local name if the parser is namespace aware, or just the element name otherwise
Throws:
  `Exception`

#### end

    public void end(String namespace,
           String name)
             throws Exception

Process the end of this element.

Overrides:
  `end` in class `Rule`
Parameters:
  `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
  `name` - the local name if the parser is namespace aware, or just the element name otherwise
Throws:
  `Exception`

#### finish

    public void finish()
                throws Exception

Clean up after parsing is complete.

Overrides:
  `finish` in class `Rule`
Throws:
  `Exception`

#### toString

    public String toString()

Render a printable version of this Rule.

Overrides:
  `toString` in class `Object`

#### getFactory

    protected ObjectCreationFactory getFactory(Attributes attributes)
                                        throws Exception

Return an instance of our associated object creation factory, creating one if necessary.

Parameters:
  `attributes` - Attributes passed to our factory creation element
Throws:
  `Exception` - if any error occurs